Index: src/UIElements/TextUI/Query/MoleculesTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/MoleculesTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/MoleculesTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,6 +31,6 @@
 
 
-TextDialog::MoleculesTextQuery::MoleculesTextQuery(std::string title, std::string _description) :
-    Dialog::MoleculesQuery(title,_description)
+TextDialog::MoleculesTextQuery::MoleculesTextQuery(Parameter<std::vector<const molecule *> > &param, std::string title, std::string _description) :
+    Dialog::MoleculesQuery(param, title,_description)
 {}
 
@@ -43,4 +43,5 @@
   getline(std::cin,line);
   // dissect by " "
+  std::vector<const molecule *> temp_mols;
   std::string::iterator olditer = line.begin();
   for(std::string::iterator iter = line.begin(); iter != line.end(); ++iter) {
@@ -53,5 +54,5 @@
         break;
       }
-      tmp.push_back(temp);
+      temp_mols.push_back(temp);
       olditer = iter;
     }
@@ -63,7 +64,8 @@
     if(!temp && idxOfMol!=-1){
       std::cout << "Invalid Molecule Index" << idxOfMol << std::endl;
-      tmp.push_back(temp);
+      temp_mols.push_back(temp);
     }
   }
+  tmp.set(temp_mols);
 
   return (idxOfMol!=-1);
Index: src/UIElements/TextUI/Query/RandomNumberDistribution_ParametersTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/RandomNumberDistribution_ParametersTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/RandomNumberDistribution_ParametersTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -30,6 +30,6 @@
 #include "RandomNumbers/RandomNumberDistribution_Parameters.hpp"
 
-TextDialog::RandomNumberDistribution_ParametersTextQuery::RandomNumberDistribution_ParametersTextQuery(std::string title, std::string _description) :
-    Dialog::RandomNumberDistribution_ParametersQuery(title,_description)
+TextDialog::RandomNumberDistribution_ParametersTextQuery::RandomNumberDistribution_ParametersTextQuery(Parameter<RandomNumberDistribution_Parameters> &param, std::string title, std::string _description) :
+    Dialog::RandomNumberDistribution_ParametersQuery(param, title,_description)
 {}
 
@@ -43,5 +43,7 @@
     std::cout << "Please enter parameters as follows: 'p=0.5;'";
     std::cout << "Empty line terminates." << std::endl;
-    std::cin >> tmp;
+    RandomNumberDistribution_Parameters temp_params;
+    std::cin >> temp_params;
+    tmp.set(temp_params);
     if(std::cin.fail()){
       badInput = true;
Index: src/UIElements/TextUI/Query/RealSpaceMatrixTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/RealSpaceMatrixTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
+++ src/UIElements/TextUI/Query/RealSpaceMatrixTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -0,0 +1,61 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * BoxTextQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <iostream>
+
+#include "TextUI/Query/TextQuery.hpp"
+
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+
+
+TextDialog::RealSpaceMatrixTextQuery::RealSpaceMatrixTextQuery(Parameter<RealSpaceMatrix> &param, std::string title, std::string _description) :
+    Dialog::RealSpaceMatrixQuery(param, title,_description)
+{}
+
+TextDialog::RealSpaceMatrixTextQuery::~RealSpaceMatrixTextQuery()
+{}
+
+bool TextDialog::RealSpaceMatrixTextQuery::handle() {
+  std::cout << getTitle();
+
+  double temp[6];
+  std::cout << getDescription() << " - ";
+  std::string coords[6] = {"xx","yx","yy", "zx", "zy", "zz"};
+  for (int i=0;i<6;i++) {
+    std::cout << coords[i] << ": ";
+    std::cin >> temp[i];
+  }
+  RealSpaceMatrix M;
+  M.set(0,0, temp[0]);
+  M.set(0,1, temp[1]);
+  M.set(0,2, temp[2]);
+  M.set(1,0, temp[1]);
+  M.set(1,1, temp[3]);
+  M.set(1,2, temp[4]);
+  M.set(2,0, temp[2]);
+  M.set(2,1, temp[4]);
+  M.set(2,2, temp[5]);
+  tmp.set(M);
+  return true;
+}
+
Index: src/UIElements/TextUI/Query/StringTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/StringTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/StringTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 
 
-TextDialog::StringTextQuery::StringTextQuery(std::string title, std::string _description) :
-    Dialog::StringQuery(title,_description)
+TextDialog::StringTextQuery::StringTextQuery(Parameter<std::string> &param, std::string title, std::string _description) :
+    Dialog::StringQuery(param, title,_description)
 {}
 
@@ -36,5 +36,7 @@
 bool TextDialog::StringTextQuery::handle() {
   std::cout << getDescription() << ": ";
-  getline(std::cin,tmp);
+  std::string temp_string;
+  getline(std::cin,temp_string);
+  tmp.set(temp_string);
   return true;
 }
Index: src/UIElements/TextUI/Query/StringsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/StringsTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/StringsTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 
 
-TextDialog::StringsTextQuery::StringsTextQuery(std::string title, std::string _description) :
-    Dialog::StringsQuery(title,_description)
+TextDialog::StringsTextQuery::StringsTextQuery(Parameter<std::vector<std::string> > &param, std::string title, std::string _description) :
+    Dialog::StringsQuery(param, title,_description)
 {}
 
@@ -38,13 +38,15 @@
   getline(std::cin,temp);
   // dissect by " "
+  std::vector<std::string> temp_strings;
   std::string::iterator olditer = temp.begin();
   for(std::string::iterator iter = temp.begin(); iter != temp.end(); ++iter) {
     if (*iter == ' ') {
-      tmp.push_back(std::string(iter, olditer));
+      temp_strings.push_back(std::string(iter, olditer));
       olditer = iter;
     }
   }
   if (olditer != temp.begin())  // insert last part also
-    tmp.push_back(std::string(olditer, temp.end()));
+    temp_strings.push_back(std::string(olditer, temp.end()));
+  tmp.set(temp_strings);
 
   return true;
Index: src/UIElements/TextUI/Query/TextQuery.hpp
===================================================================
--- src/UIElements/TextUI/Query/TextQuery.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/TextQuery.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -19,5 +19,5 @@
 class TextDialog::AtomTextQuery : public Dialog::AtomQuery {
 public:
-  AtomTextQuery(std::string title, std::string _description = NULL);
+  AtomTextQuery(Parameter<const atom *> &, std::string title, std::string _description = NULL);
   virtual ~AtomTextQuery();
   virtual bool handle();
@@ -26,5 +26,5 @@
 class TextDialog::AtomsTextQuery : public Dialog::AtomsQuery {
 public:
-  AtomsTextQuery(std::string title, std::string _description = NULL);
+  AtomsTextQuery(Parameter<std::vector<const atom *> > &, std::string title, std::string _description = NULL);
   virtual ~AtomsTextQuery();
   virtual bool handle();
@@ -33,13 +33,13 @@
 class TextDialog::BooleanTextQuery : public Dialog::BooleanQuery {
 public:
-  BooleanTextQuery(std::string title, std::string _description = NULL);
+  BooleanTextQuery(Parameter<bool> &, std::string title, std::string _description = NULL);
   virtual ~BooleanTextQuery();
   virtual bool handle();
 };
 
-class TextDialog::BoxTextQuery : public Dialog::BoxQuery {
+class TextDialog::RealSpaceMatrixTextQuery : public Dialog::RealSpaceMatrixQuery {
 public:
-  BoxTextQuery(std::string title, std::string _description = NULL);
-  virtual ~BoxTextQuery();
+  RealSpaceMatrixTextQuery(Parameter<RealSpaceMatrix> &, std::string title, std::string _description = NULL);
+  virtual ~RealSpaceMatrixTextQuery();
   virtual bool handle();
 };
@@ -47,5 +47,5 @@
 class TextDialog::DoubleTextQuery : public Dialog::DoubleQuery {
 public:
-  DoubleTextQuery(std::string title, std::string _description = NULL);
+  DoubleTextQuery(Parameter<double> &, std::string title, std::string _description = NULL);
   virtual ~DoubleTextQuery();
   virtual bool handle();
@@ -54,5 +54,5 @@
 class TextDialog::DoublesTextQuery : public Dialog::DoublesQuery {
 public:
-  DoublesTextQuery(std::string title, std::string _description = NULL);
+  DoublesTextQuery(Parameter<std::vector<double> > &, std::string title, std::string _description = NULL);
   virtual ~DoublesTextQuery();
   virtual bool handle();
@@ -61,5 +61,5 @@
 class TextDialog::ElementTextQuery : public Dialog::ElementQuery {
 public:
-  ElementTextQuery(std::string title, std::string _description = NULL);
+  ElementTextQuery(Parameter<const element *> &, std::string title, std::string _description = NULL);
   virtual ~ElementTextQuery();
   virtual bool handle();
@@ -68,5 +68,5 @@
 class TextDialog::ElementsTextQuery : public Dialog::ElementsQuery {
 public:
-  ElementsTextQuery(std::string title, std::string _description = NULL);
+  ElementsTextQuery(Parameter<std::vector<const element *> > &, std::string title, std::string _description = NULL);
   virtual ~ElementsTextQuery();
   virtual bool handle();
@@ -82,5 +82,5 @@
 class TextDialog::FileTextQuery : public Dialog::FileQuery {
 public:
-  FileTextQuery(std::string title, std::string _description = NULL);
+  FileTextQuery(Parameter<boost::filesystem::path> &, std::string title, std::string _description = NULL);
   virtual ~FileTextQuery();
   virtual bool handle();
@@ -89,5 +89,5 @@
 class TextDialog::FilesTextQuery : public Dialog::FilesQuery {
 public:
-  FilesTextQuery(std::string title, std::string _description = NULL);
+  FilesTextQuery(Parameter<std::vector< boost::filesystem::path> > &param, std::string title, std::string _description = NULL);
   virtual ~FilesTextQuery();
   virtual bool handle();
@@ -96,5 +96,5 @@
 class TextDialog::IntTextQuery : public Dialog::IntQuery {
 public:
-  IntTextQuery(std::string title, std::string _description = NULL);
+  IntTextQuery(Parameter<int> &, std::string title, std::string _description = NULL);
   virtual ~IntTextQuery();
   virtual bool handle();
@@ -103,5 +103,5 @@
 class TextDialog::IntsTextQuery : public Dialog::IntsQuery {
 public:
-  IntsTextQuery(std::string title, std::string _description = NULL);
+  IntsTextQuery(Parameter<std::vector<int> > &, std::string title, std::string _description = NULL);
   virtual ~IntsTextQuery();
   virtual bool handle();
@@ -110,5 +110,5 @@
 class TextDialog::MoleculeTextQuery : public Dialog::MoleculeQuery {
 public:
-  MoleculeTextQuery(std::string title, std::string _description = NULL);
+  MoleculeTextQuery(Parameter<const molecule *> &, std::string title, std::string _description = NULL);
   virtual ~MoleculeTextQuery();
   virtual bool handle();
@@ -117,5 +117,5 @@
 class TextDialog::MoleculesTextQuery : public Dialog::MoleculesQuery {
 public:
-  MoleculesTextQuery(std::string title, std::string _description = NULL);
+  MoleculesTextQuery(Parameter<std::vector<const molecule *> > &, std::string title, std::string _description = NULL);
   virtual ~MoleculesTextQuery();
   virtual bool handle();
@@ -124,5 +124,5 @@
 class TextDialog::StringTextQuery : public Dialog::StringQuery {
 public:
-  StringTextQuery(std::string title, std::string _description = NULL);
+  StringTextQuery(Parameter<std::string> &, std::string title, std::string _description = NULL);
   virtual ~StringTextQuery();
   virtual bool handle();
@@ -131,5 +131,5 @@
 class TextDialog::StringsTextQuery : public Dialog::StringsQuery {
 public:
-  StringsTextQuery(std::string title, std::string _description = NULL);
+  StringsTextQuery(Parameter<std::vector<std::string> > &, std::string title, std::string _description = NULL);
   virtual ~StringsTextQuery();
   virtual bool handle();
@@ -138,5 +138,5 @@
 class TextDialog::UnsignedIntTextQuery : public Dialog::UnsignedIntQuery {
 public:
-  UnsignedIntTextQuery(std::string title, std::string _description = NULL);
+  UnsignedIntTextQuery(Parameter<unsigned int> &, std::string title, std::string _description = NULL);
   virtual ~UnsignedIntTextQuery();
   virtual bool handle();
@@ -145,5 +145,5 @@
 class TextDialog::UnsignedIntsTextQuery : public Dialog::UnsignedIntsQuery {
 public:
-  UnsignedIntsTextQuery(std::string title, std::string _description = NULL);
+  UnsignedIntsTextQuery(Parameter<std::vector<unsigned int> > &, std::string title, std::string _description = NULL);
   virtual ~UnsignedIntsTextQuery();
   virtual bool handle();
@@ -152,5 +152,5 @@
 class TextDialog::VectorTextQuery : public Dialog::VectorQuery {
 public:
-  VectorTextQuery(std::string title,bool _check, std::string _description = NULL);
+  VectorTextQuery(Parameter<Vector> &, std::string title,bool _check, std::string _description = NULL);
   virtual ~VectorTextQuery();
   virtual bool handle();
@@ -159,5 +159,5 @@
 class TextDialog::VectorsTextQuery : public Dialog::VectorsQuery {
 public:
-  VectorsTextQuery(std::string title,bool _check, std::string _description = NULL);
+  VectorsTextQuery(Parameter<std::vector<Vector> > &, std::string title,bool _check, std::string _description = NULL);
   virtual ~VectorsTextQuery();
   virtual bool handle();
@@ -166,5 +166,5 @@
 class TextDialog::RandomNumberDistribution_ParametersTextQuery : public Dialog::RandomNumberDistribution_ParametersQuery {
 public:
-  RandomNumberDistribution_ParametersTextQuery(std::string title, std::string _description = NULL);
+  RandomNumberDistribution_ParametersTextQuery(Parameter<RandomNumberDistribution_Parameters> &, std::string title, std::string _description = NULL);
   virtual ~RandomNumberDistribution_ParametersTextQuery();
   virtual bool handle();
Index: src/UIElements/TextUI/Query/UnsignedIntTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/UnsignedIntTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/UnsignedIntTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 
 
-TextDialog::UnsignedIntTextQuery::UnsignedIntTextQuery(std::string title, std::string _description) :
-    Dialog::UnsignedIntQuery(title,_description)
+TextDialog::UnsignedIntTextQuery::UnsignedIntTextQuery(Parameter<unsigned int> &param, std::string title, std::string _description) :
+    Dialog::UnsignedIntQuery(param, title,_description)
 {}
 
@@ -39,5 +39,6 @@
     badInput = false;
     std::cout << getDescription() << ": ";
-    std::cin >> tmp;
+    unsigned int temp_uint;
+    std::cin >> temp_uint;
     if(std::cin.fail()){
       badInput=true;
@@ -46,4 +47,5 @@
       std::cout << "Input was not a number!" << std::endl;
     }
+    tmp.set(temp_uint);
   } while(badInput);
   // clear the input buffer of anything still in the line
Index: src/UIElements/TextUI/Query/UnsignedIntsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/UnsignedIntsTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/UnsignedIntsTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 
 
-TextDialog::UnsignedIntsTextQuery::UnsignedIntsTextQuery(std::string title, std::string _description) :
-    Dialog::UnsignedIntsQuery(title,_description)
+TextDialog::UnsignedIntsTextQuery::UnsignedIntsTextQuery(Parameter<std::vector<unsigned int> > &param, std::string title, std::string _description) :
+    Dialog::UnsignedIntsQuery(param, title,_description)
 {}
 
@@ -39,4 +39,5 @@
   getline(std::cin,line);
   // dissect by " "
+  std::vector<unsigned int> temp_uints;
   std::string::iterator olditer = line.begin();
   for(std::string::iterator iter = line.begin(); iter != line.end(); ++iter) {
@@ -44,5 +45,5 @@
       std::istringstream stream(std::string(iter, olditer));
       stream >> temp;
-      tmp.push_back(temp);
+      temp_uints.push_back(temp);
       olditer = iter;
     }
@@ -51,6 +52,7 @@
     std::istringstream stream(std::string(olditer, line.end()));
     stream >> temp;
-    tmp.push_back(temp);
+    temp_uints.push_back(temp);
   }
+  tmp.set(temp_uints);
 
   return true;
Index: src/UIElements/TextUI/Query/VectorTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/VectorTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/VectorTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,6 +31,6 @@
 
 
-TextDialog::VectorTextQuery::VectorTextQuery(std::string title, bool _check, std::string _description) :
-    Dialog::VectorQuery(title,_check,_description)
+TextDialog::VectorTextQuery::VectorTextQuery(Parameter<Vector> &param, std::string title, bool _check, std::string _description) :
+    Dialog::VectorQuery(param, title,_check,_description)
 {}
 
@@ -48,4 +48,6 @@
   getline(std::cin,line);
 
+  Vector temp_vector;
+
   // dissect by ","
   double coord = 0.;
@@ -56,5 +58,5 @@
       std::istringstream stream(std::string(iter, olditer));
       stream >> coord;
-      tmp[counter++] = coord;
+      temp_vector[counter++] = coord;
       olditer = iter;
     }
@@ -63,9 +65,10 @@
     std::istringstream stream(std::string(olditer, line.end()));
     stream >> coord;
-    tmp[counter++] = coord;
+    temp_vector[counter++] = coord;
   }
+  tmp.set(temp_vector);
 
   // check vector
-  return World::getInstance().getDomain().isValid(tmp);
+  return World::getInstance().getDomain().isValid(temp_vector);
 }
 
Index: src/UIElements/TextUI/Query/VectorsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/VectorsTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/VectorsTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,6 +31,6 @@
 
 
-TextDialog::VectorsTextQuery::VectorsTextQuery(std::string title, bool _check, std::string _description) :
-    Dialog::VectorsQuery(title,_check,_description)
+TextDialog::VectorsTextQuery::VectorsTextQuery(Parameter<std::vector<Vector> > &param, std::string title, bool _check, std::string _description) :
+    Dialog::VectorsQuery(param, title,_check,_description)
 {}
 
@@ -50,4 +50,5 @@
   // dissect by ","
   double coord = 0.;
+  std::vector<Vector> temp_vectors;
   std::string::iterator olditerspace = line.begin();
   std::string::iterator olditercomma = line.begin();
@@ -72,8 +73,9 @@
       }
       if (World::getInstance().getDomain().isValid(temp))
-        tmp.push_back(temp);
+        temp_vectors.push_back(temp);
       olditerspace = vectoriter;
     }
   }
+  tmp.set(temp_vectors);
 
   return true;
Index: src/UIElements/TextUI/TextDialog.cpp
===================================================================
--- src/UIElements/TextUI/TextDialog.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/TextDialog.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -38,86 +38,86 @@
 }
 
-void TextDialog::queryBoolean(const char* title, std::string description){
-  registerQuery(new BooleanTextQuery(title,description));
+void TextDialog::queryBoolean(Parameter<bool> &param, const char* title, std::string description){
+  registerQuery(new BooleanTextQuery(param, title,description));
 }
 
-void TextDialog::queryInt(const char* title, std::string description){
-  registerQuery(new IntTextQuery(title,description));
+void TextDialog::queryInt(Parameter<int> &param, const char* title, std::string description){
+  registerQuery(new IntTextQuery(param, title,description));
 }
 
-void TextDialog::queryInts(const char* title, std::string description){
-  registerQuery(new IntsTextQuery(title,description));
+void TextDialog::queryInts(Parameter<std::vector<int> > &param, const char* title, std::string description){
+  registerQuery(new IntsTextQuery(param, title,description));
 }
 
-void TextDialog::queryUnsignedInt(const char* title, std::string description){
-  registerQuery(new UnsignedIntTextQuery(title,description));
+void TextDialog::queryUnsignedInt(Parameter<unsigned int> &param, const char* title, std::string description){
+  registerQuery(new UnsignedIntTextQuery(param, title,description));
 }
 
-void TextDialog::queryUnsignedInts(const char* title, std::string description){
-  registerQuery(new UnsignedIntsTextQuery(title,description));
+void TextDialog::queryUnsignedInts(Parameter<std::vector<unsigned int> > &param, const char* title, std::string description){
+  registerQuery(new UnsignedIntsTextQuery(param, title,description));
 }
 
-void TextDialog::queryDouble(const char* title, std::string description){
-  registerQuery(new DoubleTextQuery(title,description));
+void TextDialog::queryDouble(Parameter<double> &param, const char* title, std::string description){
+  registerQuery(new DoubleTextQuery(param, title,description));
 }
 
-void TextDialog::queryDoubles(const char* title, std::string description){
-  registerQuery(new DoublesTextQuery(title,description));
+void TextDialog::queryDoubles(Parameter<std::vector<double> > &param, const char* title, std::string description){
+  registerQuery(new DoublesTextQuery(param, title,description));
 }
 
-void TextDialog::queryString(const char* title, std::string description){
-  registerQuery(new StringTextQuery(title,description));
+void TextDialog::queryString(Parameter<std::string> &param, const char* title, std::string description){
+  registerQuery(new StringTextQuery(param, title,description));
 }
 
-void TextDialog::queryStrings(const char* title, std::string description){
-  registerQuery(new StringsTextQuery(title,description));
+void TextDialog::queryStrings(Parameter<std::vector<std::string> > &param, const char* title, std::string description){
+  registerQuery(new StringsTextQuery(param, title,description));
 }
 
-void TextDialog::queryAtom(const char* title, std::string description) {
-  registerQuery(new AtomTextQuery(title,description));
+void TextDialog::queryAtom(Parameter<const atom *> &param, const char* title, std::string description) {
+  registerQuery(new AtomTextQuery(param, title,description));
 }
 
-void TextDialog::queryAtoms(const char* title, std::string description) {
-  registerQuery(new AtomsTextQuery(title,description));
+void TextDialog::queryAtoms(Parameter<std::vector<const atom *> > &param, const char* title, std::string description) {
+  registerQuery(new AtomsTextQuery(param, title,description));
 }
 
-void TextDialog::queryMolecule(const char* title, std::string description) {
-  registerQuery(new MoleculeTextQuery(title,description));
+void TextDialog::queryMolecule(Parameter<const molecule *> &param, const char* title, std::string description) {
+  registerQuery(new MoleculeTextQuery(param, title,description));
 }
 
-void TextDialog::queryMolecules(const char* title, std::string description) {
-  registerQuery(new MoleculesTextQuery(title,description));
+void TextDialog::queryMolecules(Parameter<std::vector<const molecule *> > &param, const char* title, std::string description) {
+  registerQuery(new MoleculesTextQuery(param, title,description));
 }
 
-void TextDialog::queryVector(const char* title, bool check, std::string description) {
-  registerQuery(new VectorTextQuery(title,check,description));
+void TextDialog::queryVector(Parameter<Vector> &param, const char* title, bool check, std::string description) {
+  registerQuery(new VectorTextQuery(param, title,check,description));
 }
 
-void TextDialog::queryVectors(const char* title, bool check, std::string description) {
-  registerQuery(new VectorsTextQuery(title,check,description));
+void TextDialog::queryVectors(Parameter<std::vector<Vector> > &param, const char* title, bool check, std::string description) {
+  registerQuery(new VectorsTextQuery(param, title,check,description));
 }
 
-void TextDialog::queryBox(const char* title, std::string description) {
-  registerQuery(new BoxTextQuery(title,description));
+void TextDialog::queryRealSpaceMatrix(Parameter<RealSpaceMatrix> &param, const char* title, std::string description) {
+  registerQuery(new RealSpaceMatrixTextQuery(param, title,description));
 }
 
-void TextDialog::queryElement(const char* title, std::string description){
-  registerQuery(new ElementTextQuery(title,description));
+void TextDialog::queryElement(Parameter<const element *> &param, const char* title, std::string description){
+  registerQuery(new ElementTextQuery(param, title,description));
 }
 
-void TextDialog::queryElements(const char* title, std::string description){
-  registerQuery(new ElementsTextQuery(title,description));
+void TextDialog::queryElements(Parameter<std::vector<const element *> > &param, const char* title, std::string description){
+  registerQuery(new ElementsTextQuery(param, title,description));
 }
 
-void TextDialog::queryFile(const char* title, std::string description){
-  registerQuery(new FileTextQuery(title,description));
+void TextDialog::queryFile(Parameter<boost::filesystem::path> &param, const char* title, std::string description){
+  registerQuery(new FileTextQuery(param, title,description));
 }
 
-void TextDialog::queryFiles(const char* title, std::string description){
-  registerQuery(new FilesTextQuery(title,description));
+void TextDialog::queryFiles(Parameter<std::vector< boost::filesystem::path> > &param, const char* title, std::string description){
+  registerQuery(new FilesTextQuery(param, title,description));
 }
 
-void TextDialog::queryRandomNumberDistribution_Parameters(const char* title, std::string description){
-  registerQuery(new RandomNumberDistribution_ParametersTextQuery(title,description));
+void TextDialog::queryRandomNumberDistribution_Parameters(Parameter<RandomNumberDistribution_Parameters> &param, const char* title, std::string description){
+  registerQuery(new RandomNumberDistribution_ParametersTextQuery(param, title,description));
 }
 
Index: src/UIElements/TextUI/TextDialog.hpp
===================================================================
--- src/UIElements/TextUI/TextDialog.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/TextDialog.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -22,4 +22,5 @@
 class element;
 class molecule;
+class RealSpaceMatrix;
 class Vector;
 
@@ -31,25 +32,25 @@
 
   virtual void queryEmpty(const char *, std::string = "");
-  virtual void queryBoolean(const char *, std::string = "");
-  virtual void queryInt(const char *, std::string = "");
-  virtual void queryInts(const char *, std::string = "");
-  virtual void queryUnsignedInt(const char *, std::string = "");
-  virtual void queryUnsignedInts(const char *, std::string = "");
-  virtual void queryString(const char*, std::string = "");
-  virtual void queryStrings(const char*, std::string = "");
-  virtual void queryDouble(const char*, std::string = "");
-  virtual void queryDoubles(const char*, std::string = "");
-  virtual void queryAtom(const char*,std::string = "");
-  virtual void queryAtoms(const char*,std::string = "");
-  virtual void queryMolecule(const char*,std::string = "");
-  virtual void queryMolecules(const char*,std::string = "");
-  virtual void queryVector(const char*,bool, std::string = "");
-  virtual void queryVectors(const char*,bool, std::string = "");
-  virtual void queryBox(const char*, std::string = "");
-  virtual void queryElement(const char*, std::string = "");
-  virtual void queryElements(const char*, std::string = "");
-  virtual void queryFile(const char*, std::string = "");
-  virtual void queryFiles(const char*, std::string = "");
-  virtual void queryRandomNumberDistribution_Parameters(const char*, std::string = "");
+  virtual void queryBoolean(Parameter<bool> &, const char *, std::string = "");
+  virtual void queryInt(Parameter<int> &, const char *, std::string = "");
+  virtual void queryInts(Parameter<std::vector<int> > &, const char *, std::string = "");
+  virtual void queryUnsignedInt(Parameter<unsigned int> &, const char *, std::string = "");
+  virtual void queryUnsignedInts(Parameter<std::vector<unsigned int> > &, const char *, std::string = "");
+  virtual void queryString(Parameter<std::string> &, const char*, std::string = "");
+  virtual void queryStrings(Parameter<std::vector<std::string> > &, const char*, std::string = "");
+  virtual void queryDouble(Parameter<double> &, const char*, std::string = "");
+  virtual void queryDoubles(Parameter<std::vector<double> > &, const char*, std::string = "");
+  virtual void queryAtom(Parameter<const atom *> &, const char*,std::string = "");
+  virtual void queryAtoms(Parameter<std::vector<const atom *> > &, const char*,std::string = "");
+  virtual void queryMolecule(Parameter<const molecule *> &, const char*,std::string = "");
+  virtual void queryMolecules(Parameter<std::vector<const molecule *> > &, const char*,std::string = "");
+  virtual void queryVector(Parameter<Vector> &, const char*,bool, std::string = "");
+  virtual void queryVectors(Parameter<std::vector<Vector> > &, const char*,bool, std::string = "");
+  virtual void queryRealSpaceMatrix(Parameter<RealSpaceMatrix> &, const char*, std::string = "");
+  virtual void queryElement(Parameter<const element *> &, const char*, std::string = "");
+  virtual void queryElements(Parameter<std::vector<const element *> > &, const char*, std::string = "");
+  virtual void queryFile(Parameter<boost::filesystem::path> &, const char*, std::string = "");
+  virtual void queryFiles(Parameter<std::vector<boost::filesystem::path> > &, const char*, std::string = "");
+  virtual void queryRandomNumberDistribution_Parameters(Parameter<RandomNumberDistribution_Parameters> &, const char*, std::string = "");
 
 protected:
@@ -60,5 +61,4 @@
   class AtomsTextQuery;
   class BooleanTextQuery;
-  class BoxTextQuery;
   class DoubleTextQuery;
   class DoublesTextQuery;
@@ -72,4 +72,5 @@
   class MoleculeTextQuery;
   class MoleculesTextQuery;
+  class RealSpaceMatrixTextQuery;
   class StringTextQuery;
   class StringsTextQuery;
